

#include "config.h"

#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>

#include "vsdb.h"
#include "panic.h"

#define NUM_PROCS 128
#define SAMPLE_DATABASE "sample.vsdb"

int
main(int argc, char *argv[])
{
        int ret;
        vsdb_t *v;
        vsdb_transaction_t *vt;
        char *s;
        unsigned ui;
        char buffer[256];
        pid_t arr[NUM_PROCS];
        struct vsdb_info vi;        

        //vsdb_set_verbose_mode(true);
        vsdb_set_die_on_error();


        memset(arr, 0, NUM_PROCS*sizeof(pid_t));


        v = vsdb_open(SAMPLE_DATABASE, O_RDWR | O_CREAT);
        if(!v)
                panicno("vsdb_open");
        vsdb_get_info(v, &vi);
        printf("Name:       %s\n", vi.name);
        printf("Time:       %lu\n", (unsigned long)vi.mtime);
        printf("Entries:    %lu\n", (unsigned long)vi.num_entries);
        printf("Generation: %lu\n", (unsigned long)vi.generation);
        printf("Key Bytes:  %lu\n", (unsigned long)vi.key_size);
        printf("Data Bytes:  %lu\n", (unsigned long)vi.data_size);
        vsdb_close(v);

        for (;;) {                                                                                                                                
                int const x = random() % NUM_PROCS;                                                                                                    
                if(arr[x] != 0)
                        kill(arr[x], SIGINT);                                                                                                                         
                arr[x] = fork();                                                                                                                      
                sleep(1);
                if (0 == arr[x]) while (1) {                                                                                                                    
                        int count = 0;
                        v = vsdb_open(SAMPLE_DATABASE, O_RDWR | O_CREAT);
                        if(!v)
                                panicno("vsdb_open");
                        do{
                                count++;
                                printf(".");
                                fflush(stdout);
                                vt = vsdb_transaction_begin(v, O_RDWR);
                                if(!vt)
                                        panicno("vsdb_transaction_begin");
                                s = vsdb_lookup_ss(vt, "counter");
                                if(s) {
                                        sscanf(s, "%u", &ui);
                                } else ui = 0;
                                snprintf(buffer, 256, "%u", ui + 1);
                                vsdb_set(vt, "counter", 7, buffer, strlen(buffer));;
                                ret = vsdb_transaction_commit(vt);
                        } while(ret > 0);
                        if(ret < 0)
                                panicno("vsdb_transaction_commit");
                        printf("counter: %.4i %u\n", count, ui);
                }                                                                                                                                     
        }                         

        /*

        do{
                printf(".");
                fflush(stdout);
                vt = vsdb_transaction_begin(v, O_RDWR);
                s = vsdb_lookup_ss(vt, "counter");
                if(s) {
                        sscanf(s, "%u", &ui);
                } else ui = 0;
                snprintf(buffer, 256, "%u", ui + 1);
                vsdb_set(vt, "counter", 7, buffer, strlen(buffer));;
                ret = vsdb_transaction_commit(vt);
        } while(ret > 0);
        if(ret < 0)
                panicno("vsdb_transaction_commit");

        printf("counter: %u\n", ui);
        */
        //sleep(1);

        return 0;
}

